program prekes;
 uses crt;
 const maxN = 19; //maximalus miestu kiekis
 type matrica = array[1..maxN, 1..maxN] of integer; //matrica atstumam tarp miestu, jei nera kelio arba i save atstumas = 0.
      miestai = array[1..maxN] of byte;       // masyvas miestu numeriam
//atspausdina marsruta M, max - miestu i faila rez
procedure RodykMarsruta(var M: miestai; max: byte; var rez: text);
 var i: byte;
begin
 for i:= 1 to max - 1 do
  Write(rez, M[i], '~>');
  
 WriteLn(rez, M[max], '~~~>', M[1], '~>...');
end;

{ Funkcija grazino ar jau buvo x elementas iki "iki" elemento pertvarkoje}
function buvo(var A: miestai; iki, x: byte): boolean;
 var i: byte;
begin
 buvo:= false;
 for i:= 1 to iki do
  if A[i] = x then buvo:= true;
end;

function S(var A: miestai; var M: matrica; iki: byte): integer;//funkcija grazina kelio ilgi iki "iki" miesto
 var suma: integer;
        i: byte;
begin
 suma:= 0;
 for i:= 1 to iki - 1 do
  suma:= suma + M[A[i]][A[i + 1]];
 S:= suma;
end;

{Procedura iesko trumpiausio kelio M magtricoj, grazina Amin - marsruta, Smin kelio ilgi }       { (jei 0 - tai bloga matrica)}
procedure RaskTrumpiausia(var Amin: miestai; var Smin: integer; var M: matrica; N: byte);
 var i, j: byte;
     griztam: boolean;
     A: miestai;
    
begin
 i:= 1;
 j:= 1;
 A[1]:= 1;
 Smin:= 0;
 repeat

  griztam:= false;  //griztam nusako - jei neradom kelio tai griztam
  case (i = N - 1) of //jei paskutinio ieskom, tai jis dar turi turet kelia i pirma.
   true: begin
          // suks cikla tol kol nebus kelio is nr[i] i nr[j] ir nuo paskutinio i pirma ir j  bus maziau uz N - maximalu
          while (buvo(A, i, j) or (M[A[i]][j] = 0) or (M[j][A[1]] = 0)) and (j < N) do
           j:= j + 1;
          // patikrina ar yra j kelias - gali nebut, jei baige sukt delto kad prasuko visus 1..N
          if not (buvo(A, i, j) or (M[A[i]][j] = 0) or (M[j][A[1]] = 0)) then
           begin                 //jei yra visdelto - priskiria i miestu matrica A, elementui i + 1 j-ota
            A[i + 1]:= j;
            if ((S(A, M, N) + M[A[1]][A[N]]) < Smin) or (Smin = 0) then // jei ilgis kelio A(1..N) + S N-A[1] mazesnis uz minimumo, tai ji priskiriam
             begin      
              Smin:= S(A, M, N) + M[A[1]][A[N]];
              Amin:= A;
             end;
            j:= j + 1; // j - ieskojima priskiriam, kad ieskotu jau kito, kai paskutinis aisku neras, ir kita kart gris
           end
          else // jei visdelto neradom kelio nustato gryzima
           griztam:= true;
         end;
   false: begin
           while ((M[A[i]][j] = 0 ) or buvo(A, i, j)) and (j < N) do // suks kol nebus kelio ar kartosis miesto numeris
            j:= j + 1;
           if not(buvo(A, i, j) or (M[A[i]][j] = 0)) then begin   // jei tikrai radom - priskiriam
            i:= i + 1;
            A[i]:= j;
            j:= 1
           end else griztam:= true; // jei ne - nustatom grizima
          end;
   end;
  if griztam then //jei nustatytas grizimas tai :
   if not(i = 1) then begin  // jei griztam ne ish pirmo
     j:= A[i] + 1;          // ieskosim nuos sekancio  jau buvusio (kad neitu vel i ta pati miesta)
     i:= i - 1               // nustatom ieskoti ankstensio miesto
   end else A[1]:= 2;  //jei griztam is pirmo, tai tiesiog - A pirmas miestas + 1 = 2 ..

  if (i < N) and (S(A, M, i) >= Smin) and (Smin <> 0) then //atmeta jau ir taip didesnius,
   begin //jei jau dabar ilgis daugiau, nei minimumas, neapsimoka ieskot, griztam
    j:= A[i] + 1;
    i:= i - 1;
   end;

 until (A[1] > 1); // kadangi turim vaziuot ratu, tai uztenka karta - kai pirmo miesto indeksas pasikeis - uzteks.. t.y. kai A[1] = 1 taps A[1] = 2
end;


{***********************  Programa  ********************************}
 var fname: string;
     failas: text;
     N, i, j: byte;
     M: matrica; //    Pradine duomenu matrica, M- atstumai.
     Smin: integer;   // trumpiausias kelias
     Amin: miestai; // A - einamas marsrutas, Amin - minimalus marsrutas.
begin
 ClrScr;

 WriteLn(' * * *  Programa Keliaujancioio Pirklio uzdaviniui spresti  * * *');
 WriteLn;

 {$I-}                                        //nuskaitomas TEISINGas vardas
 Write('Iveskite duomenu failo varda: ');
 ReadLn(fname);
 Assign(failas, fname);
 Reset(failas);
 while(IOResult <> 0) or (fname = '') do
  begin
   ClrScr;
   Write('Failas nerastas, pakartokite: ');
   ReadLn(fname);
   Assign(failas, fname);
   Reset(failas);
  end;
 {$I+}                   //skaitome iki eilutes pabaigos - pirma matricos eilute
 N:= 0;                  //tuo paciu suskiaciuojam kokio plocio - ilgio (ji kvadratine)
 While not EoLn(failas) do
  begin
   N:= N + 1;
   Read(failas, M[1][N]);
  end; 



 for i:= 2 to N do            //pradedant antra eilute nuskaitom likusius duomeni
  for j:= 1 to N do
   Read(failas, M[i][j]);
 Close(failas);

 WriteLn('Duomenys nuskaityti, is viso miestu yra: ', N);

 {$I-}                                    // gaunam TEISINGA faila rezultatam
 Write('Iveskite rezultatu failo varda: ');
 ReadLn(fname);
 Assign(failas, fname);
 Rewrite(failas);
 while(IOResult <> 0) or (fname = '') do
  begin
   ClrScr;
   Write('Kazkas negerai, pakartokite: ');
   ReadLn(fname);
   Assign(failas, fname);
   Rewrite(failas);
  end;
 {$I+}
 
 WriteLn('Laukite..');
 
 RaskTrumpiausia(Amin, Smin, M, N); //ras minimalu marsruta Amin, iligis jo Smin
 //atspausdins i faila aprasyma
 if Smin <> 0 then         //jei ilgis ne nulis - rado kelia
  begin
   Writeln(failas, 'Miestu skaicius = ', N, '.');
   WriteLn(failas, 'Vieno is trumpiausiu marsrutu tvarka:'); //gali buti daugiau - tokio pat -trumpiausio ilgio
   RodykMarsruta(Amin, N, failas); //atsakymui procedura
   writeln(failas);
   WriteLn(failas, 'Jo ilgis yra = ', Smin, '.');
  end
 else //jei nerado kelio
  begin
   Writeln(failas, 'Miestu skaicius = ', N, '.');
   WriteLn(failas, 'Deja, trumpiausias marsrutas nerastas!');
   WriteLn(failas, 'Duomenys kalidingi arba nera kelio, nera apvaziuojamo rato.');
  end;
 Close(failas); //uzdaromas
 ClrScr;
end.
